package drills.drill01.exercise3

import drills.drill01.exercise2.PrintService
import drills.drill01.exercise2.PrintServiceImpl
import java.rmi.Remote
import java.rmi.RemoteException
import java.rmi.server.UnicastRemoteObject

interface PrintServiceFactory : Remote {
    @Throws(RemoteException::class)
    fun create(name: String): PrintService
}

class ConcretePrintServiceFactory : PrintServiceFactory, UnicastRemoteObject() {
    override fun create(name: String): PrintService {
        return PrintServiceImpl(name)
    }
}
